import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class LoopConvertSIMD {

    public static void negate(int[] pixels){
        for(int idx = 0; idx < pixels.length; idx++){
            // ネガポジ反転
            pixels[idx] = (~pixels[idx]) & 0x00ffffff;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedImage img = ImageIO.read(new File("Rabbit.jpg"));
        // 画像の縦横の長さ取得
        int width = img.getWidth();
        int height = img.getHeight();

        int[] pixels = img.getRGB(0, 0, width, height, null, 0, width);

        // 電力測定のためのループ処理
        for(int i = 0; i < 3000; ++i){
            negate(pixels);
        }

       	img.setRGB(0, 0, width, height, pixels, 0, width);
        ImageIO.write(img, "jpg", new File("negative.jpg"));
    }
}
